require 'active_model'

module MyErrorMessage
  class Errors < ::ActiveModel::Errors
    def full_message(attribute, message)
      if message.start_with?('^')
        super(' ', message).strip.gsub(/^./, '')
      else
        super
      end
    end

    private
    def normalize_message(attribute, message, options)
      options = options.dup
      option_message = options[:message]
      if option_message.is_a?(Symbol) && option_message.to_s.end_with?('!')
        options[:message] = option_message.to_s.gsub(/.$/, '').to_sym
      end
      super
    end
  end
end

ActiveModel::Validations.module_eval do
  def errors
    @errors ||= MyErrorMessage::Errors.new(self)
  end
end